/**
 *  Copyright © 2026, Luis Andrés Lange <https://javacomm.net>
 *
 *  This Source Code Form is subject to the terms of the Mozilla Public
 *  License, v. 2.0. If a copy of the MPL was not distributed with this
 *  file, You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 *  ----------------------------------------------------------------------------
 *
 *  Exhibit B - "Incompatible With Secondary Licenses" Notice
 *
 *  This Source Code Form is "Incompatible With Secondary Licenses",
 *  as defined by the Mozilla Public License, v. 2.0.
 *
 *  In short:
 *  - This file may be used, modified, and distributed under MPL 2.0 only.
 *  - It may NOT be relicensed under GPL, LGPL, AGPL, or any other Secondary License.
 *
 *  Rationale:
 *  - Ensures that the code remains MPL-2.0.
 *  - Avoids legal conflicts with GPL-licensed libraries (e.g., VideoLAN).
 *  - Maximizes usability for commercial and security-critical applications.
 *
 */
package net.javacomm.protocol;

import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonSerializationContext;
import com.google.gson.JsonSerializer;
import java.lang.reflect.Type;



public class PrivateChatfileSerializer implements JsonSerializer<PRIVATECHATFILE> {

  @Override
  public JsonElement serialize(PRIVATECHATFILE privatechatfile, Type type, JsonSerializationContext context) {
    JsonObject jsonObject = new JsonObject();

    JsonObject dataset = new JsonObject();
    dataset.add(PRIVATECHATFILE.PSEUDOID, context.serialize(privatechatfile.getPseudoid()));
    dataset.add(PRIVATECHATFILE.REMOTE_PSEUDOID, context.serialize(privatechatfile.getRemotePseudoid()));
    dataset.add(PRIVATECHATFILE.REMOTE_NICKNAME, context.serialize(privatechatfile.getRemoteNickname()));
    dataset.add(PRIVATECHATFILE.NUMBER, context.serialize(privatechatfile.getNumber()));
    dataset.add(PRIVATECHATFILE.FILENAME, context.serialize(privatechatfile.getFilename()));
    dataset.add(PRIVATECHATFILE.ABSOLUTE_FILENAME, context.serialize(privatechatfile.getAbsoluteFilename()));
    dataset.add(PRIVATECHATFILE.FILESIZE, context.serialize(privatechatfile.getFilesize()));
    dataset.add(PRIVATECHATFILE.MESSAGE, context.serialize(privatechatfile.getMessage()));

    jsonObject.add(Protocol.HEADER, context.serialize(privatechatfile.getHeader()));
    jsonObject.add("COMMAND", context.serialize(privatechatfile.getCommand()));
    jsonObject.add(Protocol.DATASET, context.serialize(dataset));

    return jsonObject;
  }

}
